The m file, main_ZLB_distioary_tax.m, implements the MATLAB computations that generated the results for the
second example in the Christiano-Eichenbaum-Trabandt document, 
'Stochastic Simulation of a Nonlinear, Dynamic Stochastic Model'.

1. Studying computational results already obtained.
Computational results are stored in *.mat files. Those results can be graphed by setting previous=1 in 
line 14 and loading the right mat file in line 269.

The results are in files called results_x.mat and results_x_lump.mat. The parameterizations are identical in the
two, except that the first uses distortionary taxes and the second uses lump sum taxes. The object, x, takes on 
values, x = baseline, baseline4, baseline6, baseline8. The first indicates that the shock to government was
0.2, the second, 0.4 and the last two, 0.6, and 0.8. In the case of calculations with lump sum taxes, the integer was 
appended to lump rather than baseline.
results_theta82.mat reports results for the baseline parameterization when theta = 0.82. For reasons not understood,
the computations did not want to converge for lower values of theta. This was found to be true in the dynare code too.

All figures (in hopefully clear and useful notation) are stored in the subdirectory, figures.

Related code are stored in the 'subcodes' directory and a subdirectory in there. If you run the program, 
main_ZLB_distioary_tax.m, straight from where it sits, it will automatically go into those subdirectories.

2. Creating new computational results. 
You're probably better using the Dynare code, which is lightening fast. But, if you're a skeptic about Dynare
(I feel sorry for you, because you don't know what you're missing!) then you could just use the MATLAB code here. 
However, it does take a lot of time! 
To run this code, set previous=0; in line 14. First, the case where G is increased is solve, then the case where G
is constant is solved. Because the program solves non-linear equations you need initial conditions. If you just
want to use the steady state of all the variables, then set init=0 in line 181.
If you want to use a previously used solution as a starting value, then set init=1 and put in the name of the mat
file in the next line (where you put it depends on whether you're working with lump sum taxes (lump=1) or not (lump=0)).
The name of the mat file where the results you compute are put is results.mat

