function plt_nonl(Z_impulse,Z_without_impulse,G_path,t_g_path,A,Zss,gamma,sigma,nu,om1,eta,r_path,beta,theta,epsilon,sig,s1,s2,g,lump)

IRF = 100*(Z_impulse - Z_without_impulse)./Z_without_impulse;

%following are G and transfers in the first simulation, when there is 
% shock to government spending
G_t=A(5,:)';
tg_t=A(6,:)';
uc_ss=gamma * Zss(1)^(-gamma*sigma+gamma-1).*(1-Zss(3)).^((1-gamma)*(1-sigma));
psig=uc_ss*(g*Zss(3))^sigma;
s2=[s2,', psig = ',num2str(psig)];
V_ss=(Zss(1)^gamma*(1-Zss(3))^(1-gamma))^(1-sig)/((1-beta)*(1-sig)) + psig*(g*Zss(3))^(1-sigma)/((1-beta)*(1-sigma));

[U_t,Real_t,bg_t,R_t,Omega_t,C_t,pib_t,N_t,pst_t,tau_t,K_t,F_t,Primary_deficit,s_t,mrs,uc, ...
    pstm1_t,bgm1_t,Rm1_t,Omegam1_t,pibp1_t,Kp1_t,Fp1_t] = get_dat(Z_impulse,tg_t,G_t,r_path,eta,Zss,theta,epsilon, ...
    sigma,gamma,beta,nu,om1,psig,lump);

[U_star,Real_star,bg_star,R_star,Omega_star,C_star,pib_star,N_star,pst_star,tau_star,K_star,F_star,Primary_deficit_star,s_star,mrs_star,uc_star, ...
    pstm1_star,bgm1_star,Rm1_star,Omegam1_star,pibp1_star,Kp1_star,Fp1_star] = ... 
    get_dat(Z_without_impulse,t_g_path,G_path,r_path,eta,Zss,theta,epsilon, ...
    sigma,gamma,beta,nu,om1,psig,lump);

Y_without_impulse=Z_without_impulse(1,:)'+G_path;
disc=cumprod([1;Real_t(1:end-1)]);
num=cumsum((A(1,:)' - Y_without_impulse)./disc);
pv_g=cumsum((G_t- G_path)./disc);
mult=num./pv_g;

pow=[0:length(U_t)-1];
bb=beta.^pow;
V=sum(U_t.*bb')+beta^length(U_t)*V_ss;
V_star=sum(U_star.*bb')+beta^length(U_t)*V_ss;
LAM = (V*(1-sig)*(1-beta)-psig*(1+beta^length(U_t))*(g*Zss(3))^(1-sig)) ...
    /(V_star*(1-sig)*(1-beta)-psig*(g*Zss(3))^(1-sig));
LAM = 100*(LAM^(1/(gamma*(1-sig)))-1);


s3=[' Value of increased government consumption, measured as a constant percent increase in consumption :', ...
    num2str(LAM)];

name=['consumption '
      'Tak Yun dist'
      'employment  '
      'inflation   '
      'K           '
      'F           '
      'R           '
      'real debt   '
      'tau         '
      'Omega       '];
  
 II=[1 2 3 4 7 8 9 10];
 M=size(A,2);
 jj=1:min(150,M);
 
 ia=3;
 ib=4;
 figure('name','impulse responses')
 for ii = 1:length(II)
     i=II(ii);
     if i == 2 || i == 4 || i == 7 || i == 9
         subplot(ia,ib,ii)
         plot(jj,100*(Z_impulse(i,jj) - Z_without_impulse(i,jj)))
         ylabel('difference, times 100')
         title(name(i,:))
         axis auto
         grid on
     else
         subplot(ia,ib,ii)
         plot(jj,IRF(i,jj))
         title(name(i,:))
         ylabel('percent')
         axis auto
         grid on
     end
 end
 hout=suptitle({s1;s2;s3});
 
 subplot(ia,ib,length(II)+1)
 plot(jj,mult(jj))
 title('cumulative multiplier')
 axis auto
 grid on
 
 jjj=1:10;
 subplot(ia,ib,length(II)+2)
 plot(jjj,(A(1,jjj)' - Y_without_impulse(jjj))./((A(5,jjj)'- G_path(jjj))))
 title('static multiplier')
 axis auto
 grid on
 
 ll=1:36;
 subplot(ia,ib,length(II)+3)
 plot(ll,U_t(ll)-U_star(ll),'--')
 title('Flow Utility: with minus without G>Gss')
 axis auto
 grid on
 
 ll=1:36;
 subplot(ia,ib,length(II)+4)
 plot(ll,mrs(ll),ll,mrs_star(ll),'--')
 legend('Cost of Working, G>Gss','Cost of working, G=Gss')
 title('Proximity to first best, where cost of working = 1')
 axis auto
 grid on
 
ia=4;
ib=4;

figure('name','Stochastic Simulation With Impulse')
for ii = 1:length(II)
    i=II(ii);
     if isempty(intersect(i,[4 7])) ~= 1
         subplot(ia,ib,ii)
         plot(jj,100*(Z_impulse(II(ii),jj)-1))
         ylabel('percent')
         title(name(II(ii),:))
         axis auto
         grid on
     else
         subplot(ia,ib,ii)
         plot(jj,Z_impulse(II(ii),jj))
         title(name(II(ii),:))
         ylabel('actual')
         axis auto
         grid on
     end
end

 subplot(ia,ib,length(II)+1)
 plot(jj,Primary_deficit(jj),jj,ones(length(jj),1)*Primary_deficit(end),'--')
 legend('primary deficit','steady state')
 title('primary deficit')
 axis auto
 grid on
 
 subplot(ia,ib,length(II)+2)
 plot(jj,mrs(jj),jj,ones(length(jj),1))
 legend('cost of working','benefit of working')
 title('cost and benefit of working')
 axis auto
 grid on
 
 subplot(ia,ib,length(II)+3)
 plot(jj,100*(Real_t(jj)-1))
 ylabel('percent')
 title('Real Interest Rate')
 axis auto
 grid on
 
 subplot(ia,ib,length(II)+4)
 plot(jj,G_t(jj))
 title('government consumption')
 axis auto
 grid on
 
 subplot(ia,ib,length(II)+5)
 plot(jj,nu*mrs(jj)./(1-tau_t(jj)).*N_t(jj),jj,tg_t(jj), ...
     jj,tau_t(jj).*mrs(jj)./(1-tau_t(jj)).*N_t(jj),'--',jj,G_t(jj),'-.')
 legend('tax expenditures','lump sum taxes','labor income taxes','Government consumption')
 title('lump sum taxes and tax expenditures')
 axis auto
 grid on

figure('name','Stochastic Simulation Without Impulse')
for ii = 1:length(II)
     i=II(ii);
     if i == 4 || i == 7 
         subplot(ia,ib,ii)
         plot(jj,100*(Z_without_impulse(II(ii),jj)-1))
         ylabel('percent')
         title(name(II(ii),:))
         axis auto
         grid on
     else
         subplot(ia,ib,ii)
         plot(jj,Z_without_impulse(II(ii),jj))
         title(name(II(ii),:))
         ylabel('actual')
         axis auto
         grid on
     end
end


 subplot(ia,ib,length(II)+1)
 plot(jj,Primary_deficit_star(jj),jj,ones(length(jj),1)*Primary_deficit_star(end),'--')
 legend('primary deficit','steady state')
 title('primary deficit')
 axis auto
 grid on
 
 subplot(ia,ib,length(II)+2)
 plot(jj,mrs_star(jj),jj,ones(length(jj),1))
 legend('cost of working','benefit of working')
 title('cost and benefit of working')
 axis auto
 grid on

subplot(ia,ib,length(II)+3)
plot(jj,100*(Real_star(jj)-1))
ylabel('percent')
title('Real Interest Rate')
axis auto
grid on

subplot(ia,ib,length(II)+4)
plot(jj,G_path(jj))
title('government consumption')
axis auto
grid on

subplot(ia,ib,length(II)+5)
 plot(jj,nu*mrs_star(jj)./(1-tau_star(jj)).*N_star(jj),jj,t_g_path(jj), ...
     jj,tau_star(jj).*mrs_star(jj)./(1-tau_star(jj)).*N_star(jj),'--',jj,G_path(jj),'-.')
 legend('tax expenditures','lump sum taxes','labor income taxes','Government consumption')
 title('lump sum taxes and tax expenditures')
 axis auto
 grid on
1+1;