function [c p n infn K F R w gamma] =ss_ZLB(beta,theta,g,psi,util_type,n)
%EXPLANATION
% INPUT
% epsi : elasticity of the final good production function
% beta : discount factor
% theta : Calvo parameter
% g : government purchase per output
% psi : labor disutility
% u(C,N) = log(C) - N^(1+psi)/(1+psi);
%OUTPUT
% the associated steady state values
% gamma : the parameter for KPR
% ****NOTE****
% here I use psi to avoid futher coding.
% sigma is the same, but psi is the substitution in KPR

F=1/ (1-beta*theta);
K=F;
w=1;
p=1;
R=1/beta;
infn=1;

if strcmp(util_type,'separable')
    n = (1-g)^(   -1/(1+psi)  );
    c  = (1-g)*n;
    gamma = psi;
    
    if norm(c*n^psi-1) >1e-10
        error('Fatal error')
    end
else
    a = (1-n)/(1-g)/n;
    gamma = 1/(1+a);
    c = (1-g)*n;    
end



