function [U_t,Real_rate,bg_t,R_t,Omega_t,C_t,pib_t,N_t,pst_t,tau_t,K_t,F_t,Primary_deficit,s_t,mrs,uc, ...
    pstm1_t,bgm1_t,Rm1_t,Omegam1_t,pibp1_t,Kp1_t,Fp1_t] = get_dat(Z_impulse,tg_t,G_t,r_path,eta,Zss,theta,epsilon, ...
    sigma,gamma,beta,nu,om1,psig,lump)

%order of variables in Z: C,p*,N, pie,K,F,R,b+1,tau,om

Real_rate=Z_impulse(7,:)'./[Z_impulse(4,2:end)';1];
bg_t=Z_impulse(8,:)';
R_t=Z_impulse(7,:)';
Omega_t=Z_impulse(10,:)';
C_t=Z_impulse(1,:)';
pib_t=Z_impulse(4,:)';
N_t=Z_impulse(3,:)';
pst_t=Z_impulse(2,:)';
tau_t=Z_impulse(9,:)';
K_t=Z_impulse(5,:)';
F_t=Z_impulse(6,:)';

pstm1_t=[1;pst_t(1:end-1)];
bgm1_t=[Zss(8);bg_t(1:end-1)];
Rm1_t=[Zss(7);R_t(1:end-1)];
Omegam1_t=[Zss(10);Omega_t(1:end-1)];
pibp1_t=[pib_t(2:end);1];
Kp1_t=[K_t(2:end);1/(1-beta*theta)];
Fp1_t=[F_t(2:end);1/(1-beta*theta)];

uc = gamma * C_t.^(-gamma*sigma+gamma-1).*(1-N_t).^((1-gamma)*(1-sigma));
ucp1=[uc(2:end);uc(end)];
mrs = (1-gamma)/gamma * C_t./ (1-N_t);
Primary_deficit = G_t - (((tau_t-nu).*mrs./(1-tau_t)).*N_t+tg_t);
s_t = ((1-Zss(9))./(1-tau_t)).*mrs;

U_t=( (C_t.^gamma).*(1-N_t).^(1-gamma) ).^(1-sigma)/(1-sigma)+psig*(G_t.^(1-sigma))/(1-sigma);

err=zeros(9,length(U_t));
err(1,:)=Primary_deficit + (Rm1_t./pib_t) .* bgm1_t-bg_t;
err(2,:)=Omega_t-(bgm1_t.^(1-om1)).*(Omegam1_t.^om1);
if lump == 0
    err(3,:)=tau_t-Zss(9)-eta*(Omega_t-Zss(10));%tax policy rule not used when lump == 0 
end
err(4,:)=K_t- s_t - theta*(1./(1+r_path')).*(pibp1_t.^epsilon).*Kp1_t;
err(5,:)=F_t - 1 - theta*(1./(1+r_path')).*(pibp1_t.^(epsilon-1)).*Fp1_t;
err(6,:)=K_t./F_t - ((1-theta*(pib_t.^(epsilon-1)))./(1-theta)).^(1/(1-epsilon));
err(7,:)=pst_t-1./((1-theta)*((1-theta*(pib_t.^(epsilon-1)))/(1-theta)).^(epsilon/(epsilon-1)) ...
    +theta*(pib_t.^epsilon)./pstm1_t);
err(8,:)=1-(1./(1+r_path')).*R_t.*(ucp1./uc)./pibp1_t;
err(9,:)=C_t + G_t  -  pst_t .* N_t ;

check=1;
if check==1
II=[6 7 9 3 2];
for ii = 1:9
    if isempty(intersect(ii,II)) ~= 1
        if max(abs(err(ii,1:end-1))) > 3e-12
            error('fatal (get_dat) failed accuracy test')
        end
        if abs(err(ii,end))>4e-5
            disp('warning (get_dat) failed accuracy test')
            if abs(err(ii,end))>.001
                error('warning (get_dat) failed accuracy test')
            end
        end
    else
        if max(abs(err(ii,:))) > 3e-12
            error('fatal (get_dat) failed accuracy test')
        end
    end
end
end

